;nyquist plug-in
;version 4
;type tool
;name VZoom-Out
;author "Steve Daulton"
;release 2.4.2
;copyright "GNU General Public License v2.0 or later"


(defun select-trk (id)
  ;;; Select one track
  (aud-do-command "SelectTracks"
                  :Track id
                  :TrackCount 1
                  :Mode "Set"))


(defun restore-selection (tracks)
  ;; Re-select tracks that were previously selected.
  (dolist (id tracks)
      (aud-do-command "SelectTracks"
                      :Track id
                      :TrackCount 1
                      :Mode "Add")))


(defun zoom-out (bottom top)
  ;; Do vertical zoom.
  (setf mid (/ (+ top bottom) 2.0))
  (setf distance (- top bottom))
  (setf bottom (max -2 (- mid distance)))
  (setf top (min 2 (+ mid distance)))
  (aud-do-command "SetTrackVisuals"
                  :VZoomHigh top
                  :VZoomLow bottom))


(defun main ()
  (let ((info (aud-get-info "Tracks"))
        (idx 0)
        (trk-lst ())
        vmin vmax focused)
    ;; Collect track data.
    (dolist (trk info)
      (when (= (second (assoc 'selected trk)) 1)
        (push idx trk-lst))
      (when (= (second (assoc 'focused trk)) 1)
        (setf focused idx)
        (setf vmin (second (assoc 'vzoommin trk)))
        (setf vmax (second (assoc 'vzoommax trk))))
      (incf idx))
    (if (not focused)
        (throw 'err "Error.\nNo track has focus."))
    ;; Process
    (select-trk focused)
    (zoom-out vmin vmax)
    (restore-selection trk-lst))
    ; Return no-op.
    "")


(catch 'err (main))
